//Source file: DomainIDType.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines either the Framework or the type of entity attempting to access the Framework.
 *
 */
public final class DomainIDType implements java.io.Serializable {

    private int _value;
    private static int _size = 5;
    private static DomainIDType[] _array = new DomainIDType[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private DomainIDType(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * The Framework
     */
    public static final int _FW =  0;

    /**
     * The Framework
     */
    public static final DomainIDType FW = new DomainIDType(_FW);

    /**
     * A client application
     */
    public static final int _CLIENT_APPLICATION =  1;

    /**
     * A client application
     */
    public static final DomainIDType CLIENT_APPLICATION = new DomainIDType(_CLIENT_APPLICATION);

    /**
     * An enterprise operator
     */
    public static final int _ENT_OP =  2;

    /**
     * An enterprise operator
     */
    public static final DomainIDType ENT_OP = new DomainIDType(_ENT_OP);

    /**
     * A service instance
     */
    public static final int _SERVICE_INSTANCE =  3;

    /**
     * A service instance
     */
    public static final DomainIDType SERVICE_INSTANCE = new DomainIDType(_SERVICE_INSTANCE);

    /**
     * A service supplier
     */
    public static final int _SERVICE_SUPPLIER =  4;

    /**
     * A service supplier
     */
    public static final DomainIDType SERVICE_SUPPLIER = new DomainIDType(_SERVICE_SUPPLIER);


    /**
     * Method allows class to replace/resolve the object read from the stream before it 
     * is returned to the caller. By implementing this method, a class can directly control
     * the types and instances of its own instances being deserialized.
     *
     * @return the resolved DomainIDType object 
     */
    private Object readResolve() throws java.io.ObjectStreamException {
        return _array[_value];
    }

    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the DomainIDType object
     */
    public String getValueText() {
        switch (_value) {
            case _FW:
                return "FW";
            case _CLIENT_APPLICATION:
                return "CLIENT_APPLICATION";
            case _ENT_OP:
                return "ENT_OP";
            case _SERVICE_INSTANCE:
                return "SERVICE_INSTANCE";
            case _SERVICE_SUPPLIER:
                return "SERVICE_SUPPLIER";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 4
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static DomainIDType getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof DomainIDType)) {
            return false;
        }
        DomainIDType domainIDType = (DomainIDType) o; 
        if(!(this.getValue() == domainIDType.getValue())) {
            return false;
        }
        if (this.hashCode() != domainIDType.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // DomainIDType

