//Source file: FwAgreementInfo.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines the Sequence of Data Elements that specifies the information returned to the enterprise operator application in an event notification.
 * 
 */
public final class FwAgreementInfo implements java.io.Serializable {

    private String clientApplicationID;
    private String serviceID;
    private String serviceContractID;
    private String serviceProfileID;

    /**
     * Creates a new FwAgreementInfo instance.
     */
    public FwAgreementInfo () {}

    /**
     * Creates a new FwAgreementInfo instance.
     * @param _clientApplicationID   The ID of the client application
     * @param _serviceID   The ID of the service for whom the agreement was signed/terminated
     * @param _serviceContractID   The ID of the service contract related to the agreement if available, an empty string otherwise.
     * @param _serviceProfileID   The ID of the service profile related to the agreement if available, an empty string otherwise.
     */
    public FwAgreementInfo (String _clientApplicationID, String _serviceID, String _serviceContractID, String _serviceProfileID) {

        this.clientApplicationID = _clientApplicationID;
        this.serviceID = _serviceID;
        this.serviceContractID = _serviceContractID;
        this.serviceProfileID = _serviceProfileID;
    }

    /**
     * This method returns a clientApplicationID.
     * 
     * @return a String value
     */
    public String getClientApplicationID() {
        return clientApplicationID;
    }

    /**
     * This method returns a serviceID.
     * 
     * @return a String value
     */
    public String getServiceID() {
        return serviceID;
    }

    /**
     * This method returns a serviceContractID.
     * 
     * @return a String value
     */
    public String getServiceContractID() {
        return serviceContractID;
    }

    /**
     * This method returns a serviceProfileID.
     * 
     * @return a String value
     */
    public String getServiceProfileID() {
        return serviceProfileID;
    }


    /**
     * This method sets a clientApplicationID.
     */ 
    public void setClientApplicationID(String clientApplicationID) {
        this.clientApplicationID = clientApplicationID;
    }

    /**
     * This method sets a serviceID.
     */ 
    public void setServiceID(String serviceID) {
        this.serviceID = serviceID;
    }

    /**
     * This method sets a serviceContractID.
     */ 
    public void setServiceContractID(String serviceContractID) {
        this.serviceContractID = serviceContractID;
    }

    /**
     * This method sets a serviceProfileID.
     */ 
    public void setServiceProfileID(String serviceProfileID) {
        this.serviceProfileID = serviceProfileID;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof FwAgreementInfo)) {
            return false;
        } 
        FwAgreementInfo fwAgreementInfo = (FwAgreementInfo) o;
        if(!(this.clientApplicationID == fwAgreementInfo.clientApplicationID))  {
            return false;
        }
        if(!(this.serviceID == fwAgreementInfo.serviceID))  {
            return false;
        }
        if(!(this.serviceContractID == fwAgreementInfo.serviceContractID))  {
            return false;
        }
        if(!(this.serviceProfileID == fwAgreementInfo.serviceProfileID))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // FwAgreementInfo

