//Source file: FwEventCriteria.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines the Tagged Choice of Data Elements that specifies the criteria for an event notification to be generated.
 *
 */
public final class FwEventCriteria implements java.io.Serializable {

    private FwEventName _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new FwEventCriteria.
     * Tagged choice of data elements always have empty constructors
     */ 
    public FwEventCriteria() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a FwEventName value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public FwEventName getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a EventNameUndefined
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getEventNameUndefined() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_NAME_UNDEFINED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a EventNameUndefined
     * 
     * @param value a java.lang.String value
     */
    public void setEventNameUndefined(java.lang.String value) {
        _discriminator = FwEventName.EVENT_FW_NAME_UNDEFINED;
        _object = value;
    }

    /**
     * This method returns a ServiceTypeNameList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getServiceTypeNameList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_AVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a ServiceTypeNameList
     * 
     * @param value a String[] value
     */
    public void setServiceTypeNameList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_AVAILABLE;
        _object = value;
    }

    /**
     * This method returns a UnavailableServiceTypeNameList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getUnavailableServiceTypeNameList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_UNAVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a UnavailableServiceTypeNameList
     * 
     * @param value a String[] value
     */
    public void setUnavailableServiceTypeNameList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_UNAVAILABLE;
        _object = value;
    }

    /**
     * This method returns a CompatibleServiceTypeNameList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getCompatibleServiceTypeNameList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_MIGRATION_SERVICE_AVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a CompatibleServiceTypeNameList
     * 
     * @param value a String[] value
     */
    public void setCompatibleServiceTypeNameList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_MIGRATION_SERVICE_AVAILABLE;
        _object = value;
    }

    /**
     * This method returns a SessionCreatedList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getSessionCreatedList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_SESSION_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a SessionCreatedList
     * 
     * @param value a String[] value
     */
    public void setSessionCreatedList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_APP_SESSION_CREATED;
        _object = value;
    }

    /**
     * This method returns a SessionTerminatedList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getSessionTerminatedList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_SESSION_TERMINATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a SessionTerminatedList
     * 
     * @param value a String[] value
     */
    public void setSessionTerminatedList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_APP_SESSION_TERMINATED;
        _object = value;
    }

    /**
     * This method returns a AgreementSignedList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getAgreementSignedList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_AGREEMENT_SIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a AgreementSignedList
     * 
     * @param value a String[] value
     */
    public void setAgreementSignedList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_APP_AGREEMENT_SIGNED;
        _object = value;
    }

    /**
     * This method returns a AgreementEndedList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getAgreementEndedList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_AGREEMENT_ENDED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a AgreementEndedList
     * 
     * @param value a String[] value
     */
    public void setAgreementEndedList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_APP_AGREEMENT_ENDED;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a FwEventName value 
     */ 
    public void setUndefined(FwEventName discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof FwEventCriteria)) {
            return false;
        } else {
            FwEventCriteria fwEventCriteria= (FwEventCriteria)o;
            if(!(this._object.equals(fwEventCriteria._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(fwEventCriteria._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // FwEventCriteria

