//Source file: FwEventInfo.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines the Tagged Choice of Data Elements that specifies the information returned to the client in an event notification.
 *
 */
public final class FwEventInfo implements java.io.Serializable {

    private FwEventName _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new FwEventInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public FwEventInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a FwEventName value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public FwEventName getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a EventNameUndefined
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getEventNameUndefined() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_NAME_UNDEFINED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a EventNameUndefined
     * 
     * @param value a java.lang.String value
     */
    public void setEventNameUndefined(java.lang.String value) {
        _discriminator = FwEventName.EVENT_FW_NAME_UNDEFINED;
        _object = value;
    }

    /**
     * This method returns a ServiceIDList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getServiceIDList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_AVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a ServiceIDList
     * 
     * @param value a String[] value
     */
    public void setServiceIDList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_AVAILABLE;
        _object = value;
    }

    /**
     * This method returns a UnavailableServiceIDList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getUnavailableServiceIDList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_UNAVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a UnavailableServiceIDList
     * 
     * @param value a String[] value
     */
    public void setUnavailableServiceIDList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_UNAVAILABLE;
        _object = value;
    }

    /**
     * This method returns a MigrationServiceAvailable
     * 
     * @return  a org.csapi.jr.se.fw.FwMigrationServiceAvailableInfo value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.fw.FwMigrationServiceAvailableInfo getMigrationServiceAvailable() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_MIGRATION_SERVICE_AVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.fw.FwMigrationServiceAvailableInfo) _object);
    }

    /**
     * This method sets a MigrationServiceAvailable
     * 
     * @param value a org.csapi.jr.se.fw.FwMigrationServiceAvailableInfo value
     */
    public void setMigrationServiceAvailable(org.csapi.jr.se.fw.FwMigrationServiceAvailableInfo value) {
        _discriminator = FwEventName.EVENT_FW_MIGRATION_SERVICE_AVAILABLE;
        _object = value;
    }

    /**
     * This method returns a AppSessionCreated
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getAppSessionCreated() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_SESSION_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a AppSessionCreated
     * 
     * @param value a java.lang.String value
     */
    public void setAppSessionCreated(java.lang.String value) {
        _discriminator = FwEventName.EVENT_FW_APP_SESSION_CREATED;
        _object = value;
    }

    /**
     * This method returns a AppSessionTerminated
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getAppSessionTerminated() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_SESSION_TERMINATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a AppSessionTerminated
     * 
     * @param value a java.lang.String value
     */
    public void setAppSessionTerminated(java.lang.String value) {
        _discriminator = FwEventName.EVENT_FW_APP_SESSION_TERMINATED;
        _object = value;
    }

    /**
     * This method returns a AppAgreementSigned
     * 
     * @return  a org.csapi.jr.se.fw.FwAgreementInfo value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.fw.FwAgreementInfo getAppAgreementSigned() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_AGREEMENT_SIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.fw.FwAgreementInfo) _object);
    }

    /**
     * This method sets a AppAgreementSigned
     * 
     * @param value a org.csapi.jr.se.fw.FwAgreementInfo value
     */
    public void setAppAgreementSigned(org.csapi.jr.se.fw.FwAgreementInfo value) {
        _discriminator = FwEventName.EVENT_FW_APP_AGREEMENT_SIGNED;
        _object = value;
    }

    /**
     * This method returns a AppAgreementEnded
     * 
     * @return  a org.csapi.jr.se.fw.FwAgreementInfo value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.fw.FwAgreementInfo getAppAgreementEnded() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_APP_AGREEMENT_ENDED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.fw.FwAgreementInfo) _object);
    }

    /**
     * This method sets a AppAgreementEnded
     * 
     * @param value a org.csapi.jr.se.fw.FwAgreementInfo value
     */
    public void setAppAgreementEnded(org.csapi.jr.se.fw.FwAgreementInfo value) {
        _discriminator = FwEventName.EVENT_FW_APP_AGREEMENT_ENDED;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a FwEventName value 
     */ 
    public void setUndefined(FwEventName discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof FwEventInfo)) {
            return false;
        } else {
            FwEventInfo fwEventInfo= (FwEventInfo)o;
            if(!(this._object.equals(fwEventInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(fwEventInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // FwEventInfo

