//Source file: LoadInitVal.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines the Sequence of Data Elements that specify the pair of load level and associated load threshold value.
 * 
 */
public final class LoadInitVal implements java.io.Serializable {

    private org.csapi.jr.se.fw.LoadLevel loadLevel;
    private org.csapi.jr.se.fw.LoadThreshold loadThreshold;

    /**
     * Creates a new LoadInitVal instance.
     */
    public LoadInitVal () {}

    /**
     * Creates a new LoadInitVal instance.
     * @param _loadLevel   
     * @param _loadThreshold   
     */
    public LoadInitVal (org.csapi.jr.se.fw.LoadLevel _loadLevel, org.csapi.jr.se.fw.LoadThreshold _loadThreshold) {

        this.loadLevel = _loadLevel;
        this.loadThreshold = _loadThreshold;
    }

    /**
     * This method returns a loadLevel.
     * 
     * @return a org.csapi.jr.se.fw.LoadLevel value
     */
    public org.csapi.jr.se.fw.LoadLevel getLoadLevel() {
        return loadLevel;
    }

    /**
     * This method returns a loadThreshold.
     * 
     * @return a org.csapi.jr.se.fw.LoadThreshold value
     */
    public org.csapi.jr.se.fw.LoadThreshold getLoadThreshold() {
        return loadThreshold;
    }


    /**
     * This method sets a loadLevel.
     */ 
    public void setLoadLevel(org.csapi.jr.se.fw.LoadLevel loadLevel) {
        this.loadLevel = loadLevel;
    }

    /**
     * This method sets a loadThreshold.
     */ 
    public void setLoadThreshold(org.csapi.jr.se.fw.LoadThreshold loadThreshold) {
        this.loadThreshold = loadThreshold;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof LoadInitVal)) {
            return false;
        } 
        LoadInitVal loadInitVal = (LoadInitVal) o;
        if ((this.loadLevel != null) && (loadInitVal.loadLevel != null)) {
            if(!(this.loadLevel.equals(loadInitVal.loadLevel))) {
                return false;
            }
        }
        if ((this.loadThreshold != null) && (loadInitVal.loadThreshold != null)) {
            if(!(this.loadThreshold.equals(loadInitVal.loadThreshold))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // LoadInitVal

