//Source file: MigrationAdditionalInfoType.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * Defines the type of migration-related additional information.
 *
 */
public final class MigrationAdditionalInfoType implements java.io.Serializable {

    private int _value;
    private static int _size = 1;
    private static MigrationAdditionalInfoType[] _array = new MigrationAdditionalInfoType[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private MigrationAdditionalInfoType(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * Undefined
     */
    public static final int _MIGRATION_INFO_UNDEFINED =  0;

    /**
     * Undefined
     */
    public static final MigrationAdditionalInfoType MIGRATION_INFO_UNDEFINED = new MigrationAdditionalInfoType(_MIGRATION_INFO_UNDEFINED);


    /**
     * Method allows class to replace/resolve the object read from the stream before it 
     * is returned to the caller. By implementing this method, a class can directly control
     * the types and instances of its own instances being deserialized.
     *
     * @return the resolved MigrationAdditionalInfoType object 
     */
    private Object readResolve() throws java.io.ObjectStreamException {
        return _array[_value];
    }

    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the MigrationAdditionalInfoType object
     */
    public String getValueText() {
        switch (_value) {
            case _MIGRATION_INFO_UNDEFINED:
                return "MIGRATION_INFO_UNDEFINED";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 0
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static MigrationAdditionalInfoType getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof MigrationAdditionalInfoType)) {
            return false;
        }
        MigrationAdditionalInfoType migrationAdditionalInfoType = (MigrationAdditionalInfoType) o; 
        if(!(this.getValue() == migrationAdditionalInfoType.getValue())) {
            return false;
        }
        if (this.hashCode() != migrationAdditionalInfoType.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // MigrationAdditionalInfoType

