//Source file: Property.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes a generic 'property'. It is a structured data type consisting of a {name, value} pair.
 * 
 */
public final class Property implements java.io.Serializable {

    private String propertyName;
    private String propertyValue;

    /**
     * Creates a new Property instance.
     */
    public Property () {}

    /**
     * Creates a new Property instance.
     * @param _propertyName   
     * @param _propertyValue   
     */
    public Property (String _propertyName, String _propertyValue) {

        this.propertyName = _propertyName;
        this.propertyValue = _propertyValue;
    }

    /**
     * This method returns a propertyName.
     * 
     * @return a String value
     */
    public String getPropertyName() {
        return propertyName;
    }

    /**
     * This method returns a propertyValue.
     * 
     * @return a String value
     */
    public String getPropertyValue() {
        return propertyValue;
    }


    /**
     * This method sets a propertyName.
     */ 
    public void setPropertyName(String propertyName) {
        this.propertyName = propertyName;
    }

    /**
     * This method sets a propertyValue.
     */ 
    public void setPropertyValue(String propertyValue) {
        this.propertyValue = propertyValue;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof Property)) {
            return false;
        } 
        Property property = (Property) o;
        if(!(this.propertyName == property.propertyName))  {
            return false;
        }
        if(!(this.propertyValue == property.propertyValue))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // Property

