//Source file: ServiceProperty.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes an 'SCF property'. It is a structured data type which consists of ServicePropertyName and ServicePropertyValueList.
 * 
 */
public final class ServiceProperty implements java.io.Serializable {

    private String servicePropertyName;
    private String[] servicePropertyValueList;

    /**
     * Creates a new ServiceProperty instance.
     */
    public ServiceProperty () {}

    /**
     * Creates a new ServiceProperty instance.
     * @param _servicePropertyName   
     * @param _servicePropertyValueList   
     */
    public ServiceProperty (String _servicePropertyName, String[] _servicePropertyValueList) {

        this.servicePropertyName = _servicePropertyName;
        this.servicePropertyValueList = _servicePropertyValueList;
    }

    /**
     * This method returns a servicePropertyName.
     * 
     * @return a String value
     */
    public String getServicePropertyName() {
        return servicePropertyName;
    }

    /**
     * This method returns a servicePropertyValueList.
     * 
     * @return a String[] value
     */
    public String[] getServicePropertyValueList() {
        return servicePropertyValueList;
    }


    /**
     * This method sets a servicePropertyName.
     */ 
    public void setServicePropertyName(String servicePropertyName) {
        this.servicePropertyName = servicePropertyName;
    }

    /**
     * This method sets a servicePropertyValueList.
     */ 
    public void setServicePropertyValueList(String[] servicePropertyValueList) {
        this.servicePropertyValueList = servicePropertyValueList;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof ServiceProperty)) {
            return false;
        } 
        ServiceProperty serviceProperty = (ServiceProperty) o;
        if(!(this.servicePropertyName == serviceProperty.servicePropertyName))  {
            return false;
        }
        if(!(this.servicePropertyValueList == serviceProperty.servicePropertyValueList))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // ServiceProperty

