//Source file: ServiceTypeProperty.java
//Date: December 2006
//Framework Data Types for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes a service property associated with a service type. It defines the name and mode of the service property, and also the service property type: for example Boolean, integer. 
It is similar to, but distinct from, TpServiceProperty. The latter is associated with an actual service: it defines the service property's name and mode, but also defines the list of values assigned to it.
 * 
 */
public final class ServiceTypeProperty implements java.io.Serializable {

    private String servicePropertyName;
    private org.csapi.jr.se.fw.ServiceTypePropertyMode serviceTypePropertyMode;
    private String servicePropertyTypeName;

    /**
     * Creates a new ServiceTypeProperty instance.
     */
    public ServiceTypeProperty () {}

    /**
     * Creates a new ServiceTypeProperty instance.
     * @param _servicePropertyName   
     * @param _serviceTypePropertyMode   
     * @param _servicePropertyTypeName   
     */
    public ServiceTypeProperty (String _servicePropertyName, org.csapi.jr.se.fw.ServiceTypePropertyMode _serviceTypePropertyMode, String _servicePropertyTypeName) {

        this.servicePropertyName = _servicePropertyName;
        this.serviceTypePropertyMode = _serviceTypePropertyMode;
        this.servicePropertyTypeName = _servicePropertyTypeName;
    }

    /**
     * This method returns a servicePropertyName.
     * 
     * @return a String value
     */
    public String getServicePropertyName() {
        return servicePropertyName;
    }

    /**
     * This method returns a serviceTypePropertyMode.
     * 
     * @return a org.csapi.jr.se.fw.ServiceTypePropertyMode value
     */
    public org.csapi.jr.se.fw.ServiceTypePropertyMode getServiceTypePropertyMode() {
        return serviceTypePropertyMode;
    }

    /**
     * This method returns a servicePropertyTypeName.
     * 
     * @return a String value
     */
    public String getServicePropertyTypeName() {
        return servicePropertyTypeName;
    }


    /**
     * This method sets a servicePropertyName.
     */ 
    public void setServicePropertyName(String servicePropertyName) {
        this.servicePropertyName = servicePropertyName;
    }

    /**
     * This method sets a serviceTypePropertyMode.
     */ 
    public void setServiceTypePropertyMode(org.csapi.jr.se.fw.ServiceTypePropertyMode serviceTypePropertyMode) {
        this.serviceTypePropertyMode = serviceTypePropertyMode;
    }

    /**
     * This method sets a servicePropertyTypeName.
     */ 
    public void setServicePropertyTypeName(String servicePropertyTypeName) {
        this.servicePropertyTypeName = servicePropertyTypeName;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof ServiceTypeProperty)) {
            return false;
        } 
        ServiceTypeProperty serviceTypeProperty = (ServiceTypeProperty) o;
        if ((this.serviceTypePropertyMode != null) && (serviceTypeProperty.serviceTypePropertyMode != null)) {
            if(!(this.serviceTypePropertyMode.equals(serviceTypeProperty.serviceTypePropertyMode))) {
                return false;
            }
        }
        if(!(this.servicePropertyTypeName == serviceTypeProperty.servicePropertyTypeName))  {
            return false;
        }
        if(!(this.servicePropertyName == serviceTypeProperty.servicePropertyName))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // ServiceTypeProperty

