//Source file: Initial.java
//Date: December 2006
//Framework Access Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_access.trust_and_security;

/**
 * The Initial Framework interface is used by the client to initiate the authentication with the Framework.  This interface and the initiateAuthenticationWithVersion() method shall be implemented by a Framework. 
 *
 */
public interface Initial extends org.csapi.jr.se.CsapiInterface{

    /**
     * This method is invoked by the client to start the process of authentication with the framework, and request the use of a specific authentication method using the new method with support for backward compatibility in the framework. The returned fwDomain authInterface will be selected to match the proposed version from the Client in the Framework response. If the Framework cannot work with the proposed framework version the framework returns an error code (P_INVALID_VERSION).
     * @return fwDomain    This provides the client with a framework identifier, and a reference to call the authentication interface of the framework.																																structure TpAuthDomain {																												domainID  		TpDomainID;																									authInterface 		IpInterfaceRef;																									};
The domainID parameter is an identifier for the framework (that is TpFwID). It is used to identify the framework to the client.
The authInterface parameter is a reference to the authentication interface of the framework that is unique for each requesting client. The type of this interface is defined by the authType parameter. The client uses this interface to authenticate with the framework. 
Note, there are no identifiers used in the authentication interface to correlate requests and responses, therefore the authentication interface may not be shared amongst multiple clients.
     * @param clientDomain This identifies the client domain to the framework, and provides a reference to the authentication interface.																																							structure TpAuthDomain {																												domainID  		TpDomainID;																									authInterface 		IpInterfaceRef;																									};
The domainID parameter is an identifier either for a client application (that is TpClientAppID) or for an enterprise operator (that is TpEntOpID), or for an instance of a service for which a client application has signed a service agreement (that is TpServiceInstanceID), or for a service supplier (that is TpServiceSupplierID). It is used to identify the client domain to the framework, (see challenge() on IpAPILevelAuthentication). If the framework does not recognise the domainID, the framework returns an error code (P_INVALID_DOMAIN_ID).
A client application (identifiable by a given TpClientAppID) may optionally initiate authentication with the Framework by invoking this method multiple times. The Framework may elect to reject these subsequent requests, or may choose to associate them together as independent sessions under the same TpClientAppID.
The authInterface parameter is a reference to call the authentication interface of the client. The type of this interface is defined by the authType parameter. If the interface reference is not of the correct type, the framework returns an error code (P_INVALID_INTERFACE_TYPE).
     * @param authType This identifies the type of authentication mechanism requested by the client. It provides operators and clients with the opportunity to use an alternative to the API level Authentication interface, for example an implementation specific authentication mechanism like  CORBA Security, using the IpAuthentication interface, or Operator specific Authentication interfaces.  OSA API level Authentication is the default authentication mechanism (P_OSA_AUTHENTICATION). If P_OSA_AUTHENTICATION is selected, then the clientDomain and fwDomain authInterface parameters are references to interfaces of type Ip(Client)APILevelAuthentication. If P_AUTHENTICATION is selected, the fwDomain authInterface parameter references to interfaces of type IpAuthentication that is used when an underlying distribution technology authentication mechanism is used.
     * @param frameworkVersion This identifies the version of the Framework implemented in the client. The TpVersion is a String containing the version number. Valid version numbers are defined in the respective framework specification.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.fw.InvalidDomainIdException     Invalid client ID
     * @exception org.csapi.jr.se.InvalidInterfaceTypeException     The interface reference supplied by the client is the wrong type.
     * @exception org.csapi.jr.se.fw.InvalidAuthTypeException     Invalid type of authentication mechanism
     * @exception org.csapi.jr.se.InvalidVersionException     An invalid version is specified.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    org.csapi.jr.se.fw.AuthDomain  initiateAuthenticationWithVersion(org.csapi.jr.se.fw.AuthDomain clientDomain, String authType, String frameworkVersion) throws org.csapi.jr.se.CommonException, org.csapi.jr.se.fw.InvalidDomainIdException, org.csapi.jr.se.InvalidInterfaceTypeException, org.csapi.jr.se.fw.InvalidAuthTypeException, org.csapi.jr.se.InvalidVersionException, org.csapi.jr.se.PlatformException;


} // Initial

