//Source file: AppHeartBeatMgmt.java
//Date: December 2006
//Framework to Application Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_application.integrity;

/**
 * This interface allows the initialisation of a heartbeat supervision of the client application by the framework.  
 *
 */
public interface AppHeartBeatMgmt extends org.csapi.jr.se.CsapiInterface{

    /**
     * With this method, the framework instructs the client application to begin sending its heartbeat to the specified interface at the specified interval.
     * @param interval The time interval in milliseconds between the heartbeats.
     * @param fwInterface This parameter refers to the callback interface the heartbeat is calling.
     */
    void  enableAppHeartBeat(int interval, org.csapi.jr.se.fw.fw_application.integrity.HeartBeat fwInterface);

    /**
     * Instructs the client application to cease the sending of its heartbeat. 
     */
    void  disableAppHeartBeat();

    /**
     * Allows the administrative change of the heartbeat interval.
     * @param interval The time interval in milliseconds between the heartbeats.
     */
    void  changeInterval(int interval);


} // AppHeartBeatMgmt

