//Source file: ClientEventNotification.java
//Date: December 2006
//Framework to Enterprise Operator Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_enterprise_operator.notification;

/**
 * This interface is used by the framework to inform the client of a generic event.  The Event Notification Framework will invoke methods on the Event Notification Client Interface that is specified when the Event Notification interface is obtained. 
 *
 */
public interface ClientEventNotification extends org.csapi.jr.se.CsapiInterface{

    /**
     * This method notifies the client of the arrival of a generic event.
     * @param eventInfo Specifies specific data associated with this event. 
     * @param assignmentID Specifies the assignment id which was returned by the framework during the createNotification() method. The client can use assignment id to associate events with event specific criteria and to act accordingly.
     */
    void  reportNotification(org.csapi.jr.se.fw.FwEventInfo eventInfo, int assignmentID);

    /**
     * This method indicates to the client that all generic event notifications have been terminated (for example, due to faults detected).
     */
    void  notificationTerminated();


} // ClientEventNotification

