//Source file: EntOpAccountInfoQuery.java
//Date: December 2006
//Framework to Enterprise Operator Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_enterprise_operator.service_subscription;

/**
 * This interface is used by the enterprise operator to query information related to its own subscription account as held within the framework.
 *
 */
public interface EntOpAccountInfoQuery extends org.csapi.jr.se.CsapiInterface{

    /**
     * Query information about the enterprise operator. The enterprise operator invokes this operation to find out what information about itself is stored in the enterprise operator account object within the Framework.
     * @return enterpriseOperator    The "enterpriseOperator" parameter conveys the information stored in the EntOp object about the enterprise operator. It contains the unique "enterprise operator ID" followed by a list of  "enterprise operator properties". The enterprise operator properties is a list of name/value pairs which provide enterprise operator related information such as the name, organisation, address, phone, e-mail, fax, payment method (credit card, bank account), etc. to the framework.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.fw.AccessDeniedException     The client is not currently authenticated with the framework
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    org.csapi.jr.se.fw.EntOp  describeEntOpAccount() throws org.csapi.jr.se.CommonException, org.csapi.jr.se.fw.AccessDeniedException, org.csapi.jr.se.PlatformException;


} // EntOpAccountInfoQuery

