//Source file: FwHeartBeat.java
//Date: December 2006
//Framework to Service Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_service.integrity;

/**
 *  The service side framework heartbeat interface is used by the service instance to send the framework its heartbeat.  If a Framework is capable of invoking IpSvcHeartBeatMgmt.enableHeartBeat(), it shall implement IpFwHeartBeat and the pulse() method.
 *
 */
public interface FwHeartBeat extends org.csapi.jr.se.CsapiInterface{

    /**
     * The service instance uses this method to send its heartbeat to the framework. The framework will be expecting a pulse at the end of every interval specified in the parameter to the IpSvcHeartBeatMgmt.enableSvcHeartbeat() method.  If the pulse() is not received within the specified interval, then the service instance can be deemed to have failed the heartbeat.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    void  pulse() throws org.csapi.jr.se.CommonException, org.csapi.jr.se.PlatformException;


} // FwHeartBeat

