//Source file: FwHeartBeatMgmt.java
//Date: December 2006
//Framework to Service Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_service.integrity;

/**
 * This interface allows the initialisation of a heartbeat supervision of the framework by a service instance.  If the IpFwHeartBeatMgmt interface is implemented by a Framework, as a minimum enableHeartBeat() and disableHeartBeat() shall be implemented.
 *
 */
public interface FwHeartBeatMgmt extends org.csapi.jr.se.CsapiInterface{

    /**
     * With this method, the service instance instructs the framework to begin sending its heartbeat to the specified interface at the specified interval. 
     * @param interval The time interval in milliseconds between the heartbeats.
     * @param svcInterface This parameter refers to the callback interface the heartbeat is calling.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.InvalidInterfaceTypeException     The interface reference supplied by the client is the wrong type.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    void  enableHeartBeat(int interval, org.csapi.jr.se.fw.fw_service.integrity.SvcHeartBeat svcInterface) throws org.csapi.jr.se.CommonException, org.csapi.jr.se.InvalidInterfaceTypeException, org.csapi.jr.se.PlatformException;

    /**
     * Instructs the framework to cease the sending of its heartbeat. 
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    void  disableHeartBeat() throws org.csapi.jr.se.CommonException, org.csapi.jr.se.PlatformException;

    /**
     * Allows the administrative change of the heartbeat interval.
     * @param interval The time interval in milliseconds between the heartbeats.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    void  changeInterval(int interval) throws org.csapi.jr.se.CommonException, org.csapi.jr.se.PlatformException;


} // FwHeartBeatMgmt

