//Source file: SvcHeartBeat.java
//Date: December 2006
//Framework to Service Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_service.integrity;

/**
 * The service heartbeat interface is used by the framework to send the service instance its heartbeat.  If a Service is capable of invoking IpFwHeartBeatMgmt.enableHeartBeat(), it shall implement IpSvcHeartBeat and the pulse() method.
 *
 */
public interface SvcHeartBeat extends org.csapi.jr.se.CsapiInterface{

    /**
     * The framework uses this method to send its heartbeat to the service instance.  The service will be expecting a pulse at the end of every interval specified in the parameter to the IpFwHeartBeatMgmt.enableHeartbeat() method.  If the pulse() is not received within the specified interval, then the framework can be deemed to have failed the heartbeat.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     */
    void  pulse() throws org.csapi.jr.se.CommonException;


} // SvcHeartBeat

