//Source file: SvcOAM.java
//Date: December 2006
//Framework to Service Interfaces for 2nd draft ES 204 915-03 V1.1.1, DES/TISPAN-01032-03-OSA, Parlay 6.0

package org.csapi.jr.se.fw.fw_service.integrity;

/**
 * This interface and the systemDateTimeQuery() method are optional.
 *
 */
public interface SvcOAM extends org.csapi.jr.se.CsapiInterface{

    /**
     * This method is used by the framework to send the system date and time to the service.  The service responds with its own date and time.
     * @return clientDateAndTime    This is the date and time of the client (service).
     * @param systemDateAndTime This is the system date and time of the framework.  The error code P_INVALID_DATE_TIME_FORMAT is returned if the format of the parameter is invalid.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.InvalidTimeAndDateFormatException     Invalid date and time format provided.
     */
    String  systemDateTimeQuery(String systemDateAndTime) throws org.csapi.jr.se.CommonException, org.csapi.jr.se.InvalidTimeAndDateFormatException;


} // SvcOAM

